<?php
include('../inc/config.php');
include('../../inc/config.settings.php');
include('../../inc/common.php');
include('../../inc/class.logincheck.php');
include('../../inc/class.session.php');
include('../../inc/dbhandle.php');
include('../../inc/header.php');
include('../inc/cookie.php');
include('../inc/global.php');
include('../inc/smarty.php');
include('../inc/lib.php');
include('../inc/class.adminclient.php');
include('../inc/class.domain.php');

if ($allow_webadmin == false) {
	echo 'You are not allowed to access';
	exit;
}

$retid = (double)microtime()*100000000;
$sessid = get_val('sessid');
$f_user = get_val('f_user');
$f_pass = get_val('f_pass');
$f_checkcode = get_val('f_checkcode');
$f_result = get_val('f_result');

$f_user = trim(strtolower($f_user));
$f_pass = trim($f_pass);
$f_checkcode = trim($f_checkcode);

if (strlen($f_user) == 0 || strlen($f_pass) == 0
	|| strlen($f_user) > 256 || strlen($f_pass) > 256){
	if ($f_result == 'json')
		echo json_encode(array('result' => 'err', 'errno' => 0));
	else
		Header('Location: index.php?sessid='.$sessid.'&retid='.$retid); 

	exit; 
}

if (!preg_match('/^[0-9a-z]{32}$/i', $sessid))
	$sessid = '';

if ($sessid != '') {
	$sesshandle = New Session();
	
	$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
	$sesshandle->sessid = $sessid;
	$sesshandle->sesstype = SESSION_CODE;
	$sesshandle->timeout = 600;
	$sesshandle->enable_cookies = false;
	$sesshandle->enable_ipcheck = false;
	$session_value = $sesshandle->Load();
	$sesshandle->Kill();
}

$loginchk = new LoginCheck();
$loginchk->temp_folder = $SYSTEM_DIRECTORY['temporary'];
$loginchk->type = 1;
$errorpwd = $loginchk->Get($f_user);

if (is_array($errorpwd) && $errorpwd['ip'] >= 5) {
	if ($f_result == 'json')
		echo json_encode(array('result' => 'err', 'errno' => 1));
	else
		Header('Location: badlogin.php?err=1&retid='.$retid);

	exit;
}

if ($errorpwd_checkcode != 0) {
	if (!is_array($session_value)|| strcasecmp($session_value['checkcode'], $f_checkcode) != 0) {
		$loginchk->Set($f_user);
		
		if ($f_result == 'json')
			echo json_encode(array('result' => 'err', 'errno' => 2));
		else
			Header('Location: badlogin.php?err=2&retid='.$retid); 
		exit;
	}
}

$f_pass = password_decrypt($f_pass, $session_value['aeskey']);

$clientHandle = new admin_client($admin_server, $admin_port);

$ret = login_auth($clientHandle, $f_user, $f_pass);
if (is_array($ret) && $ret['session'] != '') {
	$domainHandle = new domain($clientHandle);
	$primarydomain = $domainHandle->get_primarydomain();

	$sesshandle = New Session();
	$sesshandle->temp_folder = $SYSTEM_DIRECTORY['temporary'];
	$sesshandle->sesstype = SESSION_ADMIN;
	
	$sessid = $sesshandle->GenSessionID($f_user);
	if ($sessid == false){
		if ($f_result == 'json')
			echo json_encode(array('result' => 'err', 'errno' => 0));
		else
			Header('Location: badlogin.php?retid='.$retid);
		exit;
	}

	$sesshandle->sessid = $sessid;
	$sesshandle->timeout = $session_timeout;
	$sesshandle->enable_cookies = true;
	$sesshandle->enable_ipcheck = $enable_ipcheck;
	
	$session_value = array();
	$session_value['session_id'] = $sessid;
	$session_value['session_token'] = $sesshandle->GenToken($sessid);
	
	$session_value['admin_auth'] = true;
	$session_value['admin_start'] = time();
	
	$session_value['lid'] = $lid;
	$session_value['session'] = $ret['session'];
	$session_value['maindomain'] = $primarydomain;
	$session_value['adminuser'] = $f_user;
	
	$adminright = array();
	if ($ret['usertype'] == 0) {
		$session_value['admintype'] = 'supper';
		
		$adminright['monitor'] = 1;
		$adminright['sign'] = 1;
		$adminright['domain'] = 1;
		$adminright['domainalias'] = 1;
		$adminright['user'] = 1;
		$adminright['group'] = 1;
		$adminright['useralias'] = 1;
		$adminright['archive'] = $ret['mailarchive'];
		
		if ($primarydomain == '')
			$session_value['initalize'] = true;
	}
	else if ($ret['usertype'] == 1) {
		$session_value['admintype'] = 'domain';

		$adminright['monitor'] = $ret['mailmonitor'];
		$adminright['sign'] = $ret['mailsign'];
		$adminright['domain'] = 1;
		$adminright['domainalias'] = 1;
		$adminright['user'] = 1;
		$adminright['group'] = 1;
		$adminright['useralias'] = 1;
		$adminright['archive'] = $ret['mailarchive'];
	}
	else if ($ret['usertype'] == 2) {
		$session_value['admintype'] = 'role';
		
		$range = explode(';', strtolower($ret['adminrange']));

		$adminright['monitor'] = in_array('sys_monitor', $range) ? 1 : 0;
		$adminright['sign'] = in_array('sys_sign', $range) ? 1 : 0;
		$adminright['domain'] = in_array('dom_domain', $range) ? 1 : 0;
		$adminright['domainalias'] = in_array('dom_alias', $range) ? 1 : 0;
		$adminright['user'] = in_array('usr_user', $range) ? 1 : 0;
		$adminright['group'] = in_array('usr_group', $range) ? 1 : 0;
		$adminright['useralias'] = in_array('usr_alias', $range) ? 1 : 0;
		$adminright['archive'] = $ret['mailarchive'];
	}
	else {
		$session_value['admintype'] = 'invalid';

		$adminright['monitor'] = 0;
		$adminright['sign'] = 0;
		$adminright['domain'] = 0;
		$adminright['domainalias'] = 0;
		$adminright['user'] = 0;
		$adminright['group'] = 0;
		$adminright['useralias'] = 0;
		$adminright['archive'] = 0;
	}
	$session_value['adminright'] = $adminright;	
	$session_value['adminrange'] = strtolower($ret['adminrange']);
	
	$session_value['patchversion'] = $ret['patchversion'];
	$session_value['newversion'] = $ret['newversion'];
	$session_value['visiturl'] = $ret['visiturl'];

	$session_value['versiontype'] = $reg_version_flag;
	if (($session_value['versiontype'] != 2 && $session_value['versiontype'] != 4) || !$system_archive)
		$session_value['adminright']['archive'] = 0;
	if ($session_value['versiontype'] == 3) {
		$session_value['adminright']['monitor'] = 0;
		$session_value['adminright']['sign'] = 0;
	}
	
	$sesshandle->Save($session_value);

	$smarty->assign('SessID', $sessid);
	$smarty->assign('TokenID', md5(uniqid(microtime()).$sessid));

	$loginchk->Clear($f_user);

	if ($f_result == 'json')
		echo json_encode(array('result' => 'ok', 'sessid' => $sessid, 'tokenid' => md5(uniqid(microtime()).$sessid)));
	else
		$smarty->display($selected_theme.'/login.htm');
}
else {
	$loginchk->Set($f_user);

	if ($f_result == 'json')
		echo json_encode(array('result' => 'err', 'errno' => 0));
	else
		Header('Location: badlogin.php?retid='.$retid);
}
?>